#include "Interaction_Model_ADD.H"
#include "MathTools.H"
#include "Message.H"

using namespace AMEGIC;
using namespace ATOOLS;
using namespace std;

Interaction_Model_ADD::Interaction_Model_ADD(MODEL::Model_Base * _model,
					   std::string _cplscheme,std::string _yukscheme) :
  Interaction_Model_Base(_model,_cplscheme,_yukscheme)
{ 
  p_moqcd     = new Interaction_Model_QCD(p_model,_cplscheme,_yukscheme); 
  p_moew      = new Interaction_Model_EW(p_model,_cplscheme,_yukscheme); 
  p_moqcdgrav = new Interaction_Model_QCD_Grav(p_model,_cplscheme,_yukscheme); 
  p_moewgrav  = new Interaction_Model_EW_Grav(p_model,_cplscheme,_yukscheme); 
}

void Interaction_Model_ADD::c_FFV(Single_Vertex* vertex,int& vanz)
{
  p_moqcd->c_FFV(vertex,vanz);
  p_moew->c_FFV(vertex,vanz);
}

void Interaction_Model_ADD::c_VVV(Single_Vertex* vertex,int& vanz)
{
  p_moqcd->c_VVV(vertex,vanz);
  p_moew->c_VVV(vertex,vanz);
}
void Interaction_Model_ADD::c_VVVV(Single_Vertex* vertex,int& vanz)
{
  p_moqcd->c_VVVV(vertex,vanz);
  p_moew->c_VVVV(vertex,vanz);
}

void Interaction_Model_ADD::c_FFS(Single_Vertex* vertex,int& vanz) {p_moew->c_FFS(vertex,vanz);}
void Interaction_Model_ADD::c_VVS(Single_Vertex* vertex,int& vanz) {p_moew->c_VVS(vertex,vanz);}
void Interaction_Model_ADD::c_SSS(Single_Vertex* vertex,int& vanz) {p_moew->c_SSS(vertex,vanz);}

void Interaction_Model_ADD::c_SSSS(Single_Vertex* vertex,int& vanz) { p_moew->c_SSSS(vertex,vanz); }
void Interaction_Model_ADD::c_SSVV(Single_Vertex* vertex,int& vanz) { p_moew->c_SSVV(vertex,vanz); }

void Interaction_Model_ADD::c_FFT(Single_Vertex* vertex,int& vanz)
{
  p_moewgrav->c_FFT(vertex,vanz);
}
void Interaction_Model_ADD::c_VVT(Single_Vertex* vertex,int& vanz)
{
  p_moqcdgrav->c_VVT(vertex,vanz);
  p_moewgrav->c_VVT(vertex,vanz);
}
void Interaction_Model_ADD::c_SST(Single_Vertex* vertex,int& vanz)
{
  p_moewgrav->c_SST(vertex,vanz);
}
void Interaction_Model_ADD::c_VVVT(Single_Vertex* vertex,int& vanz)
{
  p_moqcdgrav->c_VVVT(vertex,vanz);
  p_moewgrav->c_VVVT(vertex,vanz);
}
void Interaction_Model_ADD::c_SSST(Single_Vertex* vertex,int& vanz)
{
  p_moewgrav->c_SSST(vertex,vanz);
}
void Interaction_Model_ADD::c_FFVT(Single_Vertex* vertex,int& vanz)
{
  p_moqcdgrav->c_FFVT(vertex,vanz);
  p_moewgrav->c_FFVT(vertex,vanz);
}

Interaction_Model_ADD::~Interaction_Model_ADD()
{
  delete  p_moqcd;
  delete  p_moew;
  delete  p_moqcdgrav;
  delete  p_moewgrav;
}

















